#include <avr/sleep.h>

#define SLEEP_PIN 3
#define WAKEUP_PIN 2
#define LED_PIN 9

volatile byte flag = 0;

void setup() {
  Serial.begin(9600);
  pinMode(SLEEP_PIN, INPUT);
  pinMode(WAKEUP_PIN, INPUT);
  pinMode(LED_PIN, OUTPUT);
  digitalWrite(LED_PIN, HIGH);
  attachInterrupt(digitalPinToInterrupt(SLEEP_PIN), sleepCallback, RISING);
}

void loop() {
  if (flag) {
    Serial.println("Sleep mode attivato");
    digitalWrite(LED_PIN, LOW);
    sleep();
    digitalWrite(LED_PIN, HIGH);
    Serial.println("Sleep mode terminato");
  }
  Serial.println("...");
  delay(500);
}

void sleepCallback() {
  flag = 1;
}
  
void wakeupCallback() {
  flag = 0;
}

void sleep() {
  Serial.flush();
  sleep_enable();
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  detachInterrupt(digitalPinToInterrupt(SLEEP_PIN));
  attachInterrupt(digitalPinToInterrupt(WAKEUP_PIN), wakeupCallback, RISING);
  delay(200);
  sleep_cpu();

  // codice eseguito dopo il risveglio
  detachInterrupt(digitalPinToInterrupt(WAKEUP_PIN));
  attachInterrupt(digitalPinToInterrupt(SLEEP_PIN), sleepCallback, RISING);
  sleep_disable();
}